<script setup lang="ts">
import { computed, nextTick, ref, watch } from 'vue'

import UseStockList from '@/components/UsestockComponent/UseStockList.vue'
import USPaperItemList from '@/components/UsestockComponent/USPaperItemList.vue'
import { useAuthStore } from '@/stores/auth'
import { type USPaperItem } from '@/types/USPaperItem'
import { type Stock } from '@/types/Stock'
import type { USPaper } from '@/types/USPaper'
import UseStockPaper from './UseStockPaper.vue'
import { onMounted } from 'vue'
import { useUSPaperStore } from '@/stores/uspaper'
import { useStockUseStore } from '@/stores/stockuse'
import { useStockStore } from '@/stores/stock'
import type { VForm } from 'vuetify/components'

const usPaperStore = useUSPaperStore()
const uspaperStore = useUSPaperStore()
const authStore = useAuthStore()
const usestockStore = useStockStore()

const dialog = ref(false)
const loading = ref(false)
const form = ref(false)
const snackbar = ref(false)
const log = ref('')
const stock = ref<Stock>()
const divBsItems = ref<HTMLElement | null>(null)
const uspaperItemList = ref<typeof USPaperItemList | null>(null)
const dialogUSPaper = ref(false)
const refForm = ref<VForm | null>(null)
const selected = (p: Stock) => {
  console.log('ProductView ' + p)
  usPaperStore.addUSPaperItem(p)
  if (divBsItems.value) divBsItems.value.scrollTo(0, divBsItems.value.scrollHeight)
}
const currentUser = authStore.getCurrentUser()
const stockUseStore = useStockUseStore()
// const refreshUSPaperItems = () => {
//   uspaperStore.uspaperItems.value = [...uspaperItems.value]
// }
function showdeldialog() {
  usPaperStore.showDeleteDialog()
}
function closeDialog() {
  dialog.value = false
  nextTick(() => {
    usestockStore.clearForm()
  })
}
async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return
  await usestockStore.saveStock()
  closeDialog()
}
function openaddDialog() {
  dialog.value = true
}
function onSubmit() {}
const tab = ref(null)
onMounted(async () => {
  await stockUseStore.getStocks()
})
</script>

<template>
  <v-container fluid>
    <v-row style="height: 70px">
      <v-col style="background-color: rgba(75, 56, 42, 1)">
        <v-text style="font-size: 26px; color: white"
          ><v-icon icon="mdi-cart-minus" size="35px"></v-icon>สร้างใบใช้สินค้า</v-text
        >
      </v-col>
    </v-row>
    <v-row>
      <!-- คอลัมน์ซ้าย -->
      <v-col cols="12" md="6" style="background-color: rgba(239, 225, 202, 1)">
        <v-sheet
          min-width="300"
          max-width="800"
          max-height="630"
          elevation="6"
          color="rgba(175, 144, 93, 1)"
        >
          <v-tabs
            v-model="tab"
            color="deep-purple-accent-4"
            align-taus="center"
            bg-color="rgba(75, 56, 42, 1)"
          >
            <v-tab> Stock Material Item</v-tab>
          </v-tabs>
          <v-window v-model="tab">
            <v-window-item :value="1">
              <UseStockList :stocks="stockUseStore.stocks" @selected="selected"></UseStockList>
            </v-window-item>
          </v-window>
        </v-sheet>
      </v-col>
      <!-- คอลัมน์ขวา -->
      <v-col cols="12" md="6" style="background-color: rgba(226, 210, 184, 1)">
        <v-container style="padding: 0">
          <v-row>
            <v-col cols="12">
              <USPaperItemList
                v-model="uspaperStore.usPaperItems"
                :editable="true"
              ></USPaperItemList>
            </v-col>
            <v-col cols="12">
              <v-sheet
                max-width="600"
                min-width="300"
                max-height="200"
                min-height="100"
                elevation="3"
              >
                <v-container style="background-color: rgba(156, 124, 71, 1)">
                  <v-row>
                    <v-col cols="12" class="showtotal"
                      >รวมเงินทั้งสิ้น : {{ uspaperStore.usPaper.total }} บาท</v-col
                    >
                    <v-col cols="12" class="showtotal"
                      >รวมสินค้าทั้งสิ้น : {{ uspaperStore.usPaper.amount }} ชิ้น</v-col
                    >
                  </v-row>
                </v-container>
              </v-sheet>
            </v-col>
            <v-col cols="12">
              <v-sheet
                max-width="600"
                min-width="300"
                height="80"
                elevation="3"
                color="rgba(114, 87, 42, 1)"
              >
                <v-container>
                  <v-row>
                    <v-col cols="12" sm="6">
                      <v-btn
                        block
                        height="40px"
                        style="background-color: red; font-size: 22px; color: white"
                        @click="showdeldialog"
                        >ยกเลิก</v-btn
                      ></v-col
                    >
                    <v-col cols="12" sm="6"
                      ><v-btn
                        block
                        height="40px"
                        style="background-color: green; font-size: 22px; color: white"
                        @click="dialogUSPaper = true"
                        >บันทึกรายการ</v-btn
                      ></v-col
                    >
                  </v-row>
                </v-container>
              </v-sheet>
            </v-col>
          </v-row>
        </v-container>
      </v-col>
    </v-row>
  </v-container>
  <UseStockPaper
    v-model:modelValue="dialogUSPaper"
    :uspaper="uspaperStore.usPaper"
    :uspaperItems="uspaperStore.usPaperItems"
    @agree="
      () => {
        uspaperStore.Usestock()
      }
    "
  ></UseStockPaper>
  <v-snackbar v-model="snackbar">
    {{ Stock }}

    <template v-slot:actions>
      <v-btn color="pink" variant="text" @click="snackbar = false"> Close </v-btn>
    </template>
  </v-snackbar>
  <v-dialog v-model="usPaperStore.DeleteDialog" max-width="350px">
    <v-card style="text-align: center">
      <v-card-title style="text-align: center; font-size: large">ยกเลิก</v-card-title>
      คุณต้องการที่จะยกเลิกคําสั่งซื้อนี้หรือไม่
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn
          color="blue-darken-1"
          variant="text"
          @click="
            () => {
              usPaperStore.DeleteDialog = false
            }
          "
          >No</v-btn
        >
        <v-btn
          color="blue-darken-1"
          variant="text"
          @click="
            () => {
              usPaperStore.DeleteDialog = false
              usPaperStore.clearForm()
            }
          "
          >Yes</v-btn
        >
        <v-spacer></v-spacer>
      </v-card-actions>
    </v-card>
  </v-dialog>
  <v-dialog v-model="dialog" persistent width="1024">
    <v-card>
      <v-card-title>
        <span class="text-h5">Stock Profile</span>
      </v-card-title>
      <v-card-text>
        <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
          <v-container>
            <v-row>
              <v-col cols="6" sm="6">
                <v-text-field
                  v-model="usestockStore.editedStock.name"
                  :readonly="loading"
                  :rules="[(v) => !!v || 'Field is required']"
                  class="mb-2"
                  clearable
                  label="Name"
                ></v-text-field>
              </v-col>

              <v-col cols="6" sm="6">
                <v-text-field
                  v-model.number="usestockStore.editedStock.price"
                  :readonly="loading"
                  :rules="[(v) => !!v || 'Field is required']"
                  clearable
                  label="Price (Baht)"
                  placeholder="Enter your price"
                ></v-text-field>
              </v-col>

              <v-col cols="6" sm="6">
                <v-text-field
                  v-model.number="usestockStore.editedStock.min"
                  :readonly="loading"
                  :rules="[(v) => !!v || 'Field is required']"
                  clearable
                  label="Min"
                  placeholder="Enter your min"
                  min="0"
                ></v-text-field>
              </v-col>
              <v-col cols="6" sm="6">
                <v-text-field
                  v-model.number="usestockStore.editedStock.balance"
                  :readonly="loading"
                  clearable
                  label="Balance"
                  placeholder="Enter your balance"
                ></v-text-field>
              </v-col>
              <v-col cols="6" sm="6">
                <v-combobox
                  label="Unit"
                  :items="['Kilogram', 'Gram', 'Liter', 'Milliliter', 'piece']"
                  v-model="usestockStore.editedStock.unit"
                  variant="solo-filled"
                ></v-combobox>
              </v-col>
              <v-col cols="6" sm="6">
                <v-combobox
                  label="Status"
                  :items="['Available', 'Low', 'Out of Stock']"
                  v-model="usestockStore.editedStock.status"
                  variant="solo-filled"
                ></v-combobox>
              </v-col>
              <v-col cols="6">
                <v-img
                  :src="'http://localhost:4000/images/stocks/' + usestockStore.editedStock.image"
                  width="200"
                ></v-img>
              </v-col>
              <v-col cols="6">
                <v-file-input
                  v-model="usestockStore.editedStock.files"
                  :rules="[
                    (value) => {
                      return (
                        !value ||
                        !value.length ||
                        value[0].size < 2000000 ||
                        'Avatar size should be less than 2 MB!'
                      )
                    }
                  ]"
                  accept="image/png, image/jpeg, image/bmp"
                  label="Image"
                  placeholder="Pick an image"
                  prepend-icon="mdi-camera"
                ></v-file-input>
              </v-col>
            </v-row>
          </v-container>
        </v-form>
      </v-card-text>
      <v-card-actions>
        <v-spacer></v-spacer>
        <v-btn color="blue-darken-1" variant="text" @click="closeDialog"> Close </v-btn>
        <v-btn color="blue-darken-1" variant="text" @click="save()"> Save </v-btn>
      </v-card-actions>
    </v-card>
  </v-dialog>
</template>

<style>
.showtotal {
  font-size: 20px;
  font-family: 'Kanit';
  color: white;
}
</style>
@/types/USPaperItem
